// Events Plus

package eventsPlus
{
	function initEventsPlus(%part)
	{
		if(%part == 2)
		{
			if(eventsPlusUpdater.version > eventsPlusUpdater.version)
			{
				error("ERROR: Version " @ eventsPlusUpdater.version @ " is the newest version, this server is running " @ eventsPlusUpdater.version @ "!");
				
				if(!$server::dedicated)
				{
					messageBoxYesNo("Events Plus", "There is a new version of Events Plus!\nGo to the forum post?", "goToWebPage(\"" @ eventsPlusUpdater.forumTopic @ "\");", "");
				}
			}
			
			eventsPlusUpdater.delete();
			
			return;
		}
		
		new httpObject(eventsPlusUpdater);
		
		eventsPlusUpdater.version = "1.15";
		
		eventsPlusUpdater.get("J66291.googlepages.com:80", "/eventsPlus.txt");
		
		eventsPlusUpdater.disconnect = schedule(1000, false, "initEventsPlus", 2);
		
		registerOutputEvent(gameConnection, "MessageBoxOK", "string " @ $pref::server::maxChatLen / 2 SPC $pref::server::maxChatLen);
		
		registerOutputEvent(gameConnection, "InviteToMinigame");
		registerOutputEvent(gameConnection, "RemoveFromMinigame");
		
		registerOutputEvent(player, "SetPlayerName", "list ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4\tint 1 9 3\tstring " @ $pref::server::maxChatLen / 2 SPC $pref::server::maxChatLen);
		registerOutputEvent(player, "ResetPlayerName", "list ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4");
		
		registerOutputEvent(bot, "SetPlayerName", "list ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4\tint 1 9 3\tstring " @ $pref::server::maxChatLen / 2 SPC $pref::server::maxChatLen);
		registerOutputEvent(bot, "ResetPlayerName", "list ChatMessage 1 CenterPrint 2 BottomPrint 3 MessageBoxOK 4");
		
		registerInputEvent(fxDTSBrick, "onPlayerTalk", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame");
	}
	
	function eventsPlusUpdater::onLine(%this, %line)
	{
		cancel(%this.disconnect);
		
		%this.lines++;
		
		if(%this.lines == 1)
		{
			%this.version = %line;
		}
		
		if(%this.lines == 2)
		{
			%this.forumTopic = "http://www.blockland.us/smf/index.php?topic=" @ %line;
		}
		
		%this.disconnect = schedule(500, false, "initEventsPlus", 2);
	}
	
	function gameConnection::messageBoxOK(%this, %arg0, %client)
	{
		if(%arg0 $= "")
		{
			return;
		}
		
		commandToClient(%client, 'messageBoxOK', "Events Plus", %arg0);
	}
	
	function gameConnection::inviteToMinigame(%this, %client)
	{
		%brickOwner = getBrickGroupFromObject(%client.lastEventBrickProcessed).client;
		
		if(!isObject(%brickOwner) || !isObject(%brickOwner.minigame) || isObject(%client.minigame))
		{
			return;
		}
		
		serverCmdInviteToMiniGame(%brickOwner, %this);
	}
	
	function gameConnection::removeFromMinigame(%this, %client)
	{
		%brickOwner = getBrickGroupFromObject(%client.lastEventBrickProcessed).client;
		
		if(!isObject(%brickOwner) || !isObject(%brickOwner.minigame) || !isObject(%client.minigame))
		{
			return;
		}
		
		if(%brickOwner == %client)
		{
			messageClient(%client, '', "Don't kick yourself!");
			
			return;
		}
		
		serverCmdRemoveFromMiniGame(%brickOwner, %this);
	}
	
	function player::setPlayerName(%this, %arg0, %arg1, %arg2, %client)
	{
		if(!isObject(%this))
		{
			return;
		}
		
		%newInput = strReplace(%arg2, "%1", %client.name);
		
		if(%newInput $= %arg2)
		{
			%newInput = %newInput @ " [" @ %client.name @ "]";
		}
		
		%this.setShapeName(%newInput);
		
		if(isObject(%client) && isObject(%this.client) && %this.client == %client)
		{
			if(%arg0 == 1)
			{
				messageClient(%client, '', "\c2Your player name has been set to \c6'" @ %newInput @ "'");
			}
			
			if(%arg0 == 2)
			{
				centerPrint(%client, "\c2Your player name has been set to \c6'" @ %newInput @ "'", %arg1);
			}
			
			if(%arg0 == 3)
			{
				bottomPrint(%client, "\c2Your player name has been set to \c6'" @ %newInput @ "'", %arg1);
			}
			
			if(%arg0 == 4)
			{
				commandToClient(%client, 'messageBoxOK', "Events Plus", "Your player name has been set to '" @ %newInput @ "'.");
			}
		}
	}
	
	function player::resetPlayerName(%this, %arg0, %arg1, %client)
	{
		if(!isObject(%this))
		{
			return;
		}
		
		%this.setShapeName((isObject(%client)) ? %client.name : "");
		
		if(isObject(%client) && isObject(%this.client) && %this.client == %client)
		{
			if(%arg0 == 1)
			{
				messageClient(%client, '', "\c2Your player name has been reset.");
			}
			
			if(%arg0 == 2)
			{
				centerPrint(%client, "\c2Your player name has been reset.", %arg1);
			}
			
			if(%arg0 == 3)
			{
				bottomPrint(%client, "\c2Your player name has been reset.", %arg1);
			}
			
			if(%arg0 == 4)
			{
				commandToClient(%client, 'messageBoxOK', "Events Plus", "Your player name has been reset.");
			}
		}
	}
	
	function fxDTSBrick::onPlayerTalk(%this, %client)
	{
		$inputTarget_self = %this;
		
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		
		%this.processInputEvent("onPlayerTalk", %client);
	}
	
	function serverCmdmessageSent(%client, %message)
	{
		parent::serverCmdmessageSent(%client, %message);
		
		if(!isObject(%client.player) || %client.isSpamming)
		{
			return;
		}
		
		initContainerRadiusSearch(%client.player.getHackPosition(), %client.player.getScale() * 2, $TypeMasks::fxBrickObjectType);
		
		while((%object = containerSearchNext()) !$= 0)
		{
			%object.onPlayerTalk(%client);
		}
	}
	
	function serverCmdteamMessageSent(%client, %message)
	{
		parent::serverCmdteamMessageSent(%client, %message);
		
		if(!isObject(getMiniGameFromObject(%client)) || !isObject(%client.player))
		{
			return;
		}
		
		initContainerRadiusSearch(%client.player.getHackPosition(), %client.player.getScale() * 2, $TypeMasks::fxBrickObjectType);
		
		while((%object = containerSearchNext()) !$= 0)
		{
			%object.onPlayerTalk(%client);
		}
	}
};

activatePackage(eventsPlus);

initEventsPlus();